#include <stdio.h>
#include "project3.h"
#include "sharedcode.h"

struct distance_table dt0;
struct NeighborCosts  *neighbor0;
struct RoutePacket routing_pkt0;
struct minimum_cost_strct min_cost_strct0;

extern float clocktime;

void printdt0( int MyNodeNumber, struct NeighborCosts *neighbor, 
        struct distance_table *dtptr );

/* students to write the following two routines, and maybe some others */

/* rtinit0
      called once at the beggining of the emulation */
void rtinit0() {
    // Initialize minimum cost:
    min_cost_strct0.mincost[0] = 0;
    min_cost_strct0.mincost[1] = INFINITY;
    min_cost_strct0.mincost[2] = INFINITY;
    min_cost_strct0.mincost[3] = INFINITY;

    tracePrint("\nrtinit0() is called at time t=", 1);
    initialize_DistanceTable(NODE0, &dt0, &neighbor0);
    printdt0(NODE0, neighbor0, &dt0);
    calculate_MinCost(NODE0, &min_cost_strct0, &dt0);
    makeNsend_RoutePackets(NODE0, neighbor0, &min_cost_strct0, &dt0);
}

/* rtupdate0
      Called when current node recieves a routing packet that was sent by it's
      Directly called neighbor */
void rtupdate0( struct RoutePacket *rcvdpkt ) {
    int minUpdated = -1; // -1 == false : 0 == true
    tracePrint("\nrtupdate0() is called at time t=", 1);

    minUpdated = update_function(NODE0, &min_cost_strct0, &dt0, rcvdpkt);

    if (minUpdated == 0) {
        /* send routing package to neigbors */
        printdt0(NODE0, neighbor0, &dt0);
        calculate_MinCost(NODE0, &min_cost_strct0, &dt0);
        makeNsend_RoutePackets(NODE0, neighbor0, &min_cost_strct0, &dt0);
    } else {
        tracePrint("\nno new minimum cost found.", 1);
        printdt0(NODE0, neighbor0, &dt0);
    }
}

    /*
    for (j = 0; j < MAX_NODES; j++) {
        if (j == NODE0 || j == srcNd){
            // ignore checking neighbors min cost to myself
                and ignore checking neighbors cost to itself 
        } else if ((dt0.costs[srcNd][srcNd] + rcvdpkt->mincost[j]) < min_cost_strct0.mincost[j]) {
            minUpdated = 0;
            // update my mincost 
            min_cost_strct0.mincost[j] = dt0.costs[srcNd][srcNd] + rcvdpkt->mincost[j];
            // update my distance table 
            dt0.costs[j][srcNd] = dt0.costs[srcNd][srcNd] + rcvdpkt->mincost[j];
        }
    } */


/////////////////////////////////////////////////////////////////////
//  printdt
//  This routine is being supplied to you.  It is the same code in
//  each node and is tailored based on the input arguments.
//  Required arguments:
//  MyNodeNumber:  This routine assumes that you know your node
//                 number and supply it when making this call.
//  struct NeighborCosts *neighbor:  A pointer to the structure 
//                 that's supplied via a call to getNeighborCosts().
//                 It tells this print routine the configuration
//                 of nodes surrounding the node we're working on.
//  struct distance_table *dtptr: This is the running record of the
//                 current costs as seen by this node.  It is 
//                 constantly updated as the node gets new
//                 messages from other nodes.
/////////////////////////////////////////////////////////////////////
void printdt0( int MyNodeNumber, struct NeighborCosts *neighbor, 
		struct distance_table *dtptr ) {
    int       i, j;
    int       TotalNodes = neighbor->NodesInNetwork;     // Total nodes in network
    int       NumberOfNeighbors = 0;                     // How many neighbors
    int       Neighbors[MAX_NODES];                      // Who are the neighbors

    // Determine our neighbors 
    for ( i = 0; i < TotalNodes; i++ )  {
        if (( neighbor->NodeCosts[i] != INFINITY ) && i != MyNodeNumber )  {
            Neighbors[NumberOfNeighbors] = i;
            NumberOfNeighbors++;
        }
    }
    // Print the header
    printf("                via     \n");
    printf("   D%d |", MyNodeNumber );
    for ( i = 0; i < NumberOfNeighbors; i++ )
        printf("     %d", Neighbors[i]);
    printf("\n");
    printf("  ----|-------------------------------\n");

    // For each node, print the cost by travelling thru each of our neighbors
    for ( i = 0; i < TotalNodes; i++ )   {
        if ( i != MyNodeNumber )  {
            printf("dest %d|", i );
            for ( j = 0; j < NumberOfNeighbors; j++ )  {
                    printf( "  %4d", dtptr->costs[i][Neighbors[j]] );
            }
            printf("\n");
        }
    }
    printf("\n");
}    // End of printdt0

