#include <stdio.h>
#include "project3.h"
#include "sharedcode.h"

struct distance_table dt1;
struct NeighborCosts  *neighbor1;
struct RoutePacket routing_pkt1;
struct minimum_cost_strct min_cost_strct1;

extern float clocktime;

void printdt1( int MyNodeNumber, struct NeighborCosts *neighbor, 
        struct distance_table *dtptr );

/* students to write the following two routines, and maybe some others */

void rtinit1() {
    min_cost_strct1.mincost[0] = INFINITY;
    min_cost_strct1.mincost[1] = 0;
    min_cost_strct1.mincost[2] = INFINITY;
    min_cost_strct1.mincost[3] = INFINITY;

    tracePrint("\nrtinit1() is called at time t=", 1);
    initialize_DistanceTable(NODE1, &dt1, &neighbor1);
    printdt1(NODE1, neighbor1, &dt1); // Print distance table.
    calculate_MinCost(NODE1, &min_cost_strct1, &dt1);
    makeNsend_RoutePackets(NODE1, neighbor1, &min_cost_strct1, &dt1);
}

void rtupdate1( struct RoutePacket *rcvdpkt ) {
    int minUpdated = -1; // -1 == false : 0 == true
    tracePrint("\nrtupdate1() is called at time t=", 1);

    minUpdated = update_function(NODE1, &min_cost_strct1, &dt1, rcvdpkt);

    if (minUpdated == 0) {
        /* send routing package to neigbors */
        printdt1(NODE1, neighbor1, &dt1); // Print distance table.
        calculate_MinCost(NODE1, &min_cost_strct1, &dt1);
        makeNsend_RoutePackets(NODE1, neighbor1, &min_cost_strct1, &dt1);
    } else {
        tracePrint("\nno new minimum cost found.", 1);
        printdt1(NODE1, neighbor1, &dt1);
    }
}


/////////////////////////////////////////////////////////////////////
//  printdt
//  This routine is being supplied to you.  It is the same code in
//  each node and is tailored based on the input arguments.
//  Required arguments:
//  MyNodeNumber:  This routine assumes that you know your node
//                 number and supply it when making this call.
//  struct NeighborCosts *neighbor:  A pointer to the structure 
//                 that's supplied via a call to getNeighborCosts().
//                 It tells this print routine the configuration
//                 of nodes surrounding the node we're working on.
//  struct distance_table *dtptr: This is the running record of the
//                 current costs as seen by this node.  It is 
//                 constantly updated as the node gets new
//                 messages from other nodes.
/////////////////////////////////////////////////////////////////////
void printdt1( int MyNodeNumber, struct NeighborCosts *neighbor, 
		struct distance_table *dtptr ) {
    int       i, j;
    int       TotalNodes = neighbor->NodesInNetwork;     // Total nodes in network
    int       NumberOfNeighbors = 0;                     // How many neighbors
    int       Neighbors[MAX_NODES];                      // Who are the neighbors

    // Determine our neighbors 
    for ( i = 0; i < TotalNodes; i++ )  {
        if (( neighbor->NodeCosts[i] != INFINITY ) && i != MyNodeNumber )  {
            Neighbors[NumberOfNeighbors] = i;
            NumberOfNeighbors++;
        }
    }
    // Print the header
    printf("                via     \n");
    printf("   D%d |", MyNodeNumber );
    for ( i = 0; i < NumberOfNeighbors; i++ )
        printf("     %d", Neighbors[i]);
    printf("\n");
    printf("  ----|-------------------------------\n");

    // For each node, print the cost by travelling thru each of our neighbors
    for ( i = 0; i < TotalNodes; i++ )   {
        if ( i != MyNodeNumber )  {
            printf("dest %d|", i );
            for ( j = 0; j < NumberOfNeighbors; j++ )  {
                    printf( "  %4d", dtptr->costs[i][Neighbors[j]] );
            }
            printf("\n");
        }
    }
    printf("\n");
}    // End of printdt1

