#include <stdio.h>
#include "project3.h"
#include "sharedcode.h"

struct distance_table dt3;
struct NeighborCosts  *neighbor3;
struct RoutePacket routing_pkt3;
struct minimum_cost_strct min_cost_strct3;

extern float clocktime;

void printdt3( int MyNodeNumber, struct NeighborCosts *neighbor, 
        struct distance_table *dtptr );

/* students to write the following two routines, and maybe some others */

void rtinit3() {
    min_cost_strct3.mincost[0] = INFINITY;
    min_cost_strct3.mincost[1] = INFINITY;
    min_cost_strct3.mincost[2] = INFINITY;
    min_cost_strct3.mincost[3] = 0;

    tracePrint("\nrtinit2() is called at time t=", 1);
    initialize_DistanceTable(NODE3, &dt3, &neighbor3);
    printdt3(NODE3, neighbor3, &dt3); // Print distance table.
    calculate_MinCost(NODE3, &min_cost_strct3, &dt3);
    makeNsend_RoutePackets(NODE3, neighbor3, &min_cost_strct3, &dt3);
}


void rtupdate3( struct RoutePacket *rcvdpkt ) {
    int minUpdated = -1; // -1 == false : 0 == true
    tracePrint("\nrtupdate3() is called at time t=", 1);

    minUpdated = update_function(NODE3, &min_cost_strct3, &dt3, rcvdpkt);

    if (minUpdated == 0) {
        /* send routing package to neigbors */
        printdt3(NODE3, neighbor3, &dt3); // Print distance table.
        calculate_MinCost(NODE3, &min_cost_strct3, &dt3);
        makeNsend_RoutePackets(NODE3, neighbor3, &min_cost_strct3, &dt3);
    } else {
        tracePrint("\nno new minimum cost found.", 1);
        printdt3(NODE3, neighbor3, &dt3);
    }
}


/////////////////////////////////////////////////////////////////////
//  printdt
//  This routine is being supplied to you.  It is the same code in
//  each node and is tailored based on the input arguments.
//  Required arguments:
//  MyNodeNumber:  This routine assumes that you know your node
//                 number and supply it when making this call.
//  struct NeighborCosts *neighbor:  A pointer to the structure 
//                 that's supplied via a call to getNeighborCosts().
//                 It tells this print routine the configuration
//                 of nodes surrounding the node we're working on.
//  struct distance_table *dtptr: This is the running record of the
//                 current costs as seen by this node.  It is 
//                 constantly updated as the node gets new
//                 messages from other nodes.
/////////////////////////////////////////////////////////////////////
void printdt3( int MyNodeNumber, struct NeighborCosts *neighbor, 
		struct distance_table *dtptr ) {
    int       i, j;
    int       TotalNodes = neighbor->NodesInNetwork;     // Total nodes in network
    int       NumberOfNeighbors = 0;                     // How many neighbors
    int       Neighbors[MAX_NODES];                      // Who are the neighbors

    // Determine our neighbors 
    for ( i = 0; i < TotalNodes; i++ )  {
        if (( neighbor->NodeCosts[i] != INFINITY ) && i != MyNodeNumber )  {
            Neighbors[NumberOfNeighbors] = i;
            NumberOfNeighbors++;
        }
    }
    // Print the header
    printf("                via     \n");
    printf("   D%d |", MyNodeNumber );
    for ( i = 0; i < NumberOfNeighbors; i++ )
        printf("     %d", Neighbors[i]);
    printf("\n");
    printf("  ----|-------------------------------\n");

    // For each node, print the cost by travelling thru each of our neighbors
    for ( i = 0; i < TotalNodes; i++ )   {
        if ( i != MyNodeNumber )  {
            printf("dest %d|", i );
            for ( j = 0; j < NumberOfNeighbors; j++ )  {
                    printf( "  %4d", dtptr->costs[i][Neighbors[j]] );
            }
            printf("\n");
        }
    }
    printf("\n");
}    // End of printdt3

